require "http/client"
require "kemal"
require "json"
require "./config"

CONFIG = Config.load

allowed_ips = Array(String).new

def ip_address(env) : String
  begin
    return env.request.headers.try &.["X-Forwarded-For"]
  rescue
    return env.request.remote_address.to_s.split(":").first
  end
end

get "/" do |env|
  if !allowed_ips.includes?(ip_address(env))
    render "src/views/captcha.ecr"
  else
    render "src/views/main.html"
  end
end

post "/captcha" do |env|
  #   token = env.params.body["mcaptcha__token"]
  token = env.params.json["token"]
  data = JSON.build do |j|
    j.object do
      j.field "token", token
      j.field "key", CONFIG.mcaptchaSitekey
      j.field "secret", CONFIG.mcaptchaAccountSecret
    end
  end
  req = HTTP::Client.post("https://#{CONFIG.mcaptchaInstance}/api/v1/pow/siteverify",
    headers: HTTP::Headers{"Content-Type" => "application/json"},
    body: data)

  if req.success?
    res = JSON.parse(req.body)
  end

  allowed_ips << ip_address(env)
  res
end

Kemal.run
